{-----------------------------------------------------------------------------
Generate by CVS
# $Id: StrConW.pas,v 1.2 2004/06/21 15:29:41 xwing Exp $
# $Author: xwing $
# $State: Exp $
# $Date: 2004/06/21 15:29:41 $
# $Revision: 1.2 $
# $Log: uScw.pas,v $
# Revision 1.2  2004/06/21 15:29:41  xwing
#
{-----------------------------------------------------------------------------
 Unit Name: StrConW
 Author:    xwing, China
 eMail :    xwing@263.net ; xwing1979@hotmail.com
 Purpose:   WideString manipulation fuctions.
-----------------------------------------------------------------------------}
unit StrConW;

interface
uses
  windows, sysutils, unicode;

type
//TWideStringCollection - global instance "scw" declared below------------------
  TWideStringCollection = class
    //Ansi unicode conversions--------------------------------------------------
    function ToWideChar(const s: string): WideChar;
    function ToWideString(UCSet: array of Cardinal): WideString;

    //Strip/Trim and Purge------------------------------------------------------
    function Strip(const s : WideString; c : WideChar = WideChar(' ')) : WideString;
    function Trim(const s : WideString; c : WideChar = WideChar(' ')) : WideString;
    function Purge(const s : WideString; cSet : array of WideChar) : WideString;
    function PurgeWhile(const s : WideString; cSet : array of WideChar) : WideString;
    function PurgeWhileRev(const s : WideString; cSet : array of WideChar) : WideString;
    function PurgeWhileOuter(const s : WideString; cSet : array of WideChar) : WideString;

    //Compare and Informational-------------------------------------------------
    function IsSame(const s1, s2 : WideString; StripChar : WideChar = WideNull) : boolean;
    function IsSameIC(const s1, s2 : WideString; StripChar : WideChar = WideNull) : boolean;
    function IsSameFirst(SubStr, s : WideString; StripChar : WideChar = WideNull) : boolean;
    function IsSameFirstIC(SubStr, s : WideString; StripChar : WideChar = WideNull) : boolean;

    function IsLast(const SubStr, s : WideString) : boolean;
    function HasChar(c : WideChar; const s : WideString) : Boolean;
    function HasCharIC(c : WideChar; const s : WideString) : boolean;

    //Manipulation----------------------------------------------------------------
    function Ins(const SubStr, s : WideString; Index : integer) : WideString;
    function Copy(const s : WideString; Index, Count : integer) : WideString;
    function SetAt(const s : WideString; const c : WideChar; Index : integer) : WideString;
    function Center(const s: WideString; Len: integer; PadChar : Widechar = ' '): WideString;
    function ReplaceChars(const s : WideString; OldChars : array of WideChar;
      NewChar : WideChar) : WideString;
    function Replace(FindStr, ReplaceWith, InStr : WideString) : WideString; overload;
    function Replace(FindStr, ReplaceWith, InStr : WideString;
      WholeWord, CaseSensitive : boolean; Delims : array of WideChar) : WideString; overload;
    function ReplaceFirst(FindStr, ReplaceAllStr, InStr : WideString; wholeword : boolean;
      CaseSensitive : boolean; Delims : array of WideChar; var StartAt : integer) : WideString;

    //Delete--------------------------------------------------------------------
    function Del(const SubStr, s : WideString): WideString;
    function DelIfFirst(const SubStr, s : WideString) : WideString;
    function DelIfLast(const SubStr, s : WideString) : WideString;
    function Cut(var s : WideString; Index, Count : integer) : WideString;

    //Positional----------------------------------------------------------------
    function Pos(const SubStr, s : WideString; StartPos : Cardinal = 0; IgnoreCase : boolean = false) : integer;
    function PosRev(SubStr, s : WideString; IgnoreCase : boolean = false) : integer;
//
    function After(const SubStr : WideString; const s : WideString; Position : Cardinal = 0) : WideString; overload;
    function After(const cSet: array of WideChar; const s : WideString) : WideString; overload;
    function AfterRev(const SubStr : WideString; const s : WideString) : WideString; overload;
    function AfterRev(const cSet: array of WideChar; const s : WideString) : WideString; overload;
    function AfterIC(const SubStr : WideString; const s : WideString; Position : Cardinal = 0) : WideString;
    function AfterNth(const SubStr : WideString; const s : WideString; Nth : integer=0) : WideString;
//
    function Before(const SubStr : WideString; const s : WideString; Position : Cardinal = 0) : WideString; overload;
    function Before(const cSet: array of WideChar; const s : WideString) : WideString; overload;
    function BeforeRev(const SubStr : WideString; const s : WideString) : WideString; overload;
    function BeforeRev(const cSet: array of WideChar; const s : WideString) : WideString; overload;
    function BeforeIC(const SubStr : WideString; const s : WideString;Position : Cardinal = 0) : WideString;
    function BeforeNth(const SubStr : WideString; const s: WideString;Nth : integer=0): WideString;
//
//
    function At(const s : WideString; Index : integer) : WideChar;
    function First(const s : WideString; count : integer = 1) : WideString;
    function Last(const s : WideString; count : integer = 1) : WideString;
    function FirstWChar(const s: WideString): WideChar;
    function LastWChar(const s: WideString) : WideChar;
//    function FirstWord(const s: string; Delims : TCharSet = [' ']) : string;
//    function LastWord(const s: string; Delims : TCharSet= [' ']) : string;
//
//    function LeftAt(const s : string; Position : integer) : string;
//    function RightAt(const s : string; Position : integer) : string;
//
    function Parse(const SubStr: WideString; var s: WideString; Position: Cardinal = 0): WideString; overload;
    function Parse(const cSet: array of WideChar; var s: WideString): WideString; overload;

    //Miscellaneous---------------------------------------------------------------
//    function Rev(const s : string) : string;
    function RepeatChar(c : WideChar; Count : integer) : WideString;
//    function RepeatStr(const s : string; Count : integer) : string;
//    function Sort(const s : string) : string;
    function SlashAdd(const s : WideString) : WideString;
    function SlashDel(const s : WideString) : WideString;
//    function CharsetToVisualStr(const aSet: TCharset; DoRange: boolean = true): string;
//    function VisualStrToCharSet(s: string): TCharset;
//    function  MakePChar(const s : string) : PChar;
//    procedure FreePChar(var p : PChar);
  end;

var
  scw : TWideStringCollection;

implementation
{-------------------------------------------------------------------------------
*WCharInArray - Detect if the given char is in the specified array
 Example: WCharInArray('a',['a','b','c']) = true;
-------------------------------------------------------------------------------}


function WCharInArray(const c: WideChar; ca: array of WideChar): Boolean;
var
  i: Integer;
Begin
  Result := False;
  for i := 0 to High(ca) do
    if c = ca[i] then
    Begin
      Result := True;
      Break;
    end;{if}
end;

{ TWideStringCollection }

function TWideStringCollection.ToWideChar(const s: string): WideChar;
begin
  if s <> '' then
    StringToWideChar(s, @Result, 2);
end;

function TWideStringCollection.ToWideString(UCSet: array of Cardinal): WideString;
var
  i:Integer;
  w:WideChar;
begin
  SetLength(Result, (High(UCSet) + 1));
  for i := 0 to High(UCSet) do
  Begin
    w := WideChar(UCSet[i]);
    Result[i + 1] := w;
  end;
end;

{------------------------------------------------------------------------------}
function TWideStringCollection.Strip(const s: WideString; c: WideChar): WideString;
var
   i,l : integer;
   f   : boolean;
begin
  Result := WideString('');
  l := Length(s);
  i := 1;
  f := true;
  while (i <= l) and (s[i] = c) do
    Inc(i);
  if i <= l then
  begin
    while s[l] = c do
      Dec(l);
    for i := i to l do
    begin
      if (s[i] = c) then
      begin
        if f then
          Result := Result + s[i];
        f := false;
      end
      else begin
        Result := Result + s[i];
        f := true;
      end;{if}
    end;{for}
  end;{if}
end;

function TWideStringCollection.Trim(const s: WideString; c: WideChar): WideString;
var
  i, l: Integer;
begin
  l := Length(s);
  i := 1;
  while (i <= l) and (s[i] = c) do
    Inc(i);
  if i > l then
    Result := ''
  else begin
    while s[l] = c do
      Dec(l);
    Result := System.Copy(s, i, l - i + 1);
  end;{if}
end;

{-------------------------------------------------------------------------------
*Purge - Removes a character from a string
 Example: Purge('hello world',' ') --> 'helloworld'
See also overloaded TCharSet version
-------------------------------------------------------------------------------}
function TWideStringCollection.Purge(const s: WideString; cSet: array of WideChar): WideString;
var
  i : integer;
begin
  Result := WideString('');
  for i := 1 to Length(s) do
    if not WCharInArray(s[i], cSet) then
      Result := Result + s[i];
end;

{-------------------------------------------------------------------------------
*PurgeWhile
 This function purges characters contained in aSet from the left until
 it encounters a character not found in the set.
 Example: PurgeWhile('helloWORLDhello',['a'..'z']) > 'WORLDhello'
-------------------------------------------------------------------------------}
function TWideStringCollection.PurgeWhile(const s: WideString; cSet: array of WideChar): WideString;
var
  i : integer;
begin
  Result := widestring('');
  for i := 1 to Length(s) do
  begin
    if not WCharInArray(s[i], cSet) then
    begin
      Result := System.Copy(s, i, Length(s));
      break;
    end;
  end;
end;

{-------------------------------------------------------------------------------
*PurgeWhileRev
 This function purges characters contained in aSet from the right util
 it encounters a character not found in the set.
 Example: PurgeWhileRev('helloWORLDhello',['a'..'z']) > 'helloWORLD'
-------------------------------------------------------------------------------}
function TWideStringCollection.PurgeWhileRev(const s: WideString; cSet: array of WideChar): WideString;
var
  i : integer;
begin
  Result := WideString('');
  for i := Length(s) downto 1 do
  begin
    if not WCharInArray(s[i], cSet) then
    begin
      Result := System.Copy(s, 1, i);
      break;
    end;
  end;
end;

{-------------------------------------------------------------------------------
*PurgeWhileOuter - a combination of functions PurgeWhile and PurgeWhileRev.
 It first returns characters from the left while they are not found in aSet,
 then repeats the process from the right.
 Example: PurgeWhileOuter('helloWORLDxWORLDhello',['a'..'z']) > 'WORLDxWORLD'
 Example: PurgeWhileOuter('123letters45letters',['A'..'z']) > '123letters45'
See also PurgeWhile,PurgeWhileRev
-------------------------------------------------------------------------------}
function TWideStringCollection.PurgeWhileOuter(const s: WideString;
  cSet: array of WideChar): WideString;
begin
  Result := PurgeWhileRev(PurgeWhile(s, cSet), cSet);
end;

{------------------------------------------------------------------------------}
function TWideStringCollection.IsSame(const s1, s2: WideString; StripChar: WideChar): boolean;
begin
  if StripChar <> WideNull then
    Result := (Strip(s1, StripChar) = Strip(s2, StripChar))
  else
    Result := (s1 = s2);
end;

function TWideStringCollection.IsSameIC(const s1, s2: WideString; StripChar: WideChar): boolean;
begin
  if StripChar <> WideNull then
    Result := SysUtils.WideSameText(Strip(s1, StripChar), Strip(s2, StripChar))
  else
    Result := SysUtils.WideSameText(s1, s2);
end;

function TWideStringCollection.IsSameFirst(SubStr, s: WideString; StripChar: WideChar): boolean;
begin
  if StripChar <> WideNull then
  begin
    SubStr := Strip(SubStr, Stripchar);
    s := Strip(s, Stripchar);
  end;
  Result := (SubStr = System.Copy(s, 1, Length(SubStr)));
end;

function TWideStringCollection.IsSameFirstIC(SubStr, s: WideString; StripChar: WideChar): boolean;
begin
  if StripChar <> WideNull then
  begin
    SubStr := Strip(SubStr, Stripchar);
    s := Strip(s, Stripchar);
  end;
  Result := SysUtils.WideSameText(SubStr, System.Copy(s, 1, Length(SubStr)));
end;

function TWideStringCollection.IsLast(const SubStr, s: WideString): boolean;
begin
  if length(SubStr) > length(s) then
    Result := false
  else
    Result := System.Copy(s, (length(s) + 1) - length(SubStr), length(SubStr)) = SubStr;
end;

{-------------------------------------------------------------------------------
*Del - Deletes a SubStr from s.
 Example: Del('the','the moon is the light') > ' moon is   light';
-------------------------------------------------------------------------------}
function TWideStringCollection.Del(const SubStr, s: WideString): WideString;
begin
  Result := s;
  while Pos(SubStr, Result) > 0 do
  begin
    if Pos(SubStr, Result) = 1 then
      Result := System.Copy(Result, Length(SubStr) + 1, Length(Result))
    else
      Result := System.Copy(Result, 1, Pos(SubStr, Result) - 1 ) +
        System.Copy(Result, Pos(SubStr, Result) + Length(SubStr), Length(Result));
  end;
end;

function TWideStringCollection.DelIfFirst(const SubStr, s: WideString): WideString;
begin
  if System.Copy(s, 1, Length(SubStr)) = SubStr then
    Result := System.Copy(s, length(SubStr) + 1, length(s))
  else
    Result := s;
end;

function TWideStringCollection.DelIfLast(const SubStr, s: WideString): WideString;
begin
  if IsLast(SubStr, s) then
    Result := System.Copy(s, 1, length(s) - length(SubStr))
  else
    Result := s;
end;

{-------------------------------------------------------------------------------
*Cut - Deletes the characters defined by Index and Count from s and returns the
 deleted portion.
 Example: Cut('hello',2,2 ) > 'el'   'hello' > 'hlo';
-------------------------------------------------------------------------------}
function TWideStringCollection.Cut(var s: WideString; Index, Count: integer): WideString;
begin
	Result := System.Copy(s, Index, Count);
  Delete(s, Index, Count );
end;

{------------------------------------------------------------------------------}
function TWideStringCollection.HasChar(c: WideChar; const s: WideString): Boolean;
begin
  Result := system.Pos(c, s) > 0;
end;

function TWideStringCollection.HasCharIC(c: WideChar; const s: WideString): boolean;
begin
  Result := System.Pos(WideUpCase(c), sysutils.WideUpperCase(s)) > 0;
end;

{-------------------------------------------------------------------------------
*Pos - Same as standard Pos function, except that you also can specify the start.
 position, and ignore the case.
 Example: Pos('the','the man there',2) > 9
 Example: Pos('THE','the man there',2,true) > 9
 Note that StartPos 1 and 0 is functionally the same.
-------------------------------------------------------------------------------}
function TWideStringCollection.Pos(const SubStr, s: WideString;
  StartPos: Cardinal; IgnoreCase: boolean): integer;
begin
  if StartPos = 0 then
  begin
    if IgnoreCase then
      Result := System.Pos(WideUpperCase(SubStr), WideUpperCase(s))
    else
      Result := System.Pos(SubStr, s)
  end
  else begin
    if IgnoreCase then
      Result := System.Pos(WideUpperCase(SubStr), WideUpperCase(System.Copy(s, StartPos, Length(s))))
    else
      Result := System.Pos(SubStr, System.Copy(s, StartPos, Length(s)));
    if Result > 0 then
      Result := (Result + integer(StartPos)) - 1;
  end;
end;

{-------------------------------------------------------------------------------
*PosRev - Same as standard Pos string function except that it scans backwards.
-------------------------------------------------------------------------------}
function TWideStringCollection.PosRev(SubStr, s: WideString;
  IgnoreCase: boolean): integer;
var
  i : integer;

 function IsMatch : boolean;
 var
  j : integer;
 begin
   Result := false;
   for j := 2 to Length(SubStr) do
    if SubStr[j] <> s[i+(j-1)] then
      exit;
   Result := true;
 end;

var
  l : integer;
begin
  Result := 0;
  if IgnoreCase then
  begin
    s := WideUpperCase(s);
    SubStr := WideUpperCase(SubStr);
  end;
  l := Length(SubStr);
  if l = 0 then
    exit;
  for i := Length(s) downto 1 do
  begin
    if s[i] = SubStr[1] then
    begin
      if l = 1 then
      begin
        Result := i;
        exit;
      end
      else begin
        if IsMatch then
        begin
          Result := i;
          exit;
        end;{if}
      end;{else}
    end;{if}
  end;{for}
end;

{-------------------------------------------------------------------------------
*After
 Scans for SubStr in s - if found the characters after SubStr is returned else
 an empty string is returned.
 Example: After('Funny','Those Funny People') > ' People';
 Example: After('land','Your land is my land ok',1) > ' is my land ok'
 Example: After('land','Your land is my land ok',7) > ' ok'
 Example: After('not there','Your land is my land ok') > ''
See also Before,Parse,AfterIC,AfterRev and Set overloaded versions.
-------------------------------------------------------------------------------}
function TWideStringCollection.After(const SubStr, s: WideString; Position: Cardinal): WideString;
var
  p : integer;
begin
  p := Pos(SubStr, s, Position);
  if p = 0 then
    Result := ''
  else
    Result := System.Copy(s, p+Length(SubStr), Length(s));
end;

function TWideStringCollection.After(const cSet: array of WideChar; const s: WideString): WideString;
var
  i : integer;
begin
  for i := 1 to length(s) do
  begin
    if WCharInArray(s[i], cSet) then
    begin
      Result := System.Copy(s, i+1, length(s));
      exit;
    end;
  end;
  Result := '';
end;

function TWideStringCollection.AfterIC(const SubStr, s: WideString; Position: Cardinal): WideString;
var
  p : integer;
begin
  p := Pos(SubStr, s, Position, true);
  if p = 0 then
    Result := ''
  else
    Result := System.Copy(s, p+Length(SubStr), Length(s));
end;

{-------------------------------------------------------------------------------
*AfterNth - Returns the string after the <Nth> appearance of SubStr.
 Example: AfterNth('tree','Green tree, blue tree everywhere',1) > ', blue tree everywhere'
 Example: AfterNth('tree','Green tree, blue tree everywhere',2) > ' everywhere'
See also After,BeforeNth
-------------------------------------------------------------------------------}
function TWideStringCollection.AfterNth(const SubStr, s: WideString; Nth: integer): WideString;
var
  i : integer;
begin
  if Nth <= 1 then
    Result := After(SubStr, s)
  else begin
    Result := s;
    for i := 1 to Nth do
      Result := After(SubStr, Result);
  end;
end;
{-------------------------------------------------------------------------------
*AfterRev
 This functions scans s for SubStr from the right and returns the portion after
 SubStr.
 Example: AfterRev('.','c:\my.file.txt') > '.txt'
See also After,BeforeRev
-------------------------------------------------------------------------------}
function TWideStringCollection.AfterRev(const SubStr, s: WideString): WideString;
var
  p : integer;
begin
  p := PosRev(SubStr, s);
  if p = 0 then
    Result := ''
  else
    Result := System.Copy(s, p+Length(SubStr), Length(s));
end;

function TWideStringCollection.AfterRev(const cSet: array of WideChar;
  const s: WideString): WideString;
var
  i : integer;
begin
  for i := length(s) downto 1 do
  begin
    if WCharInArray(s[i], cSet) then
    begin
      Result := System.Copy(s, i+1, length(s));
      exit;
    end;
  end;
  Result := '';
end;

{-------------------------------------------------------------------------------
*Before
 Scans for SubStr in s - if found the characters before SubStr is returned else
 the complete string is returned.
 Example: Before(' People','Those Funny People') > 'Those Funny';
 Example: Before('land','Your land is my land',1) > 'Your';
 Example: Before('land','Your land is my land',7) > 'Your land is my ';
 Example: Before('not there','Your land is my land') > 'Your land is my land'
See also After,BeforeIC,BeforeRev
-------------------------------------------------------------------------------}
function TWideStringCollection.Before(const SubStr, s: WideString; Position: Cardinal): WideString;
var
  p : integer;
begin
  p := Pos(SubStr, s, Position);
  if p = 0 then
    Result := s
  else
    Result := System.Copy(s, 1, p-1);
end;

function TWideStringCollection.Before(const cSet: array of WideChar; const s: WideString): WideString;
var
  i : integer;
begin
  for i := 1 to length(s) do
  begin
    if WCharInArray(s[i], cSet) then
    begin
      Result := System.Copy(s, 1, i-1);
      exit;
    end;
  end;
  Result := s;
end;

function TWideStringCollection.BeforeIC(const SubStr, s: WideString; Position: Cardinal): WideString;
var
  p : integer;
begin
  p := Pos(SubStr, s, Position, true);
  if p = 0 then
    Result := s
  else
    Result := System.Copy(s, 1, p-1);
end;

function TWideStringCollection.BeforeNth(const SubStr, s: WideString; Nth: integer): WideString;
var
  i : integer;
  p : integer;
begin
  if Nth <= 1 then
    Result := Before(SubStr, s)
  else begin
    p := 1;
    for i := 1 to Nth do
      p := Pos(SubStr, s, p+1);
    if p=0 then
      Result := s
    else
      Result := System.Copy(s,1,p-1);
  end;
end;

{-------------------------------------------------------------------------------
*BeforeRev
 This function scans a string from the right and returns the portion of the
 string before SubStr.
 Example: BeforeRev('.','c:\my.file.txt') > 'c:\my.file'
See also Before,AfterRev
-------------------------------------------------------------------------------}
function TWideStringCollection.BeforeRev(const SubStr, s: WideString): WideString;
var
  p : Integer;
begin
  p := PosRev(SubStr, s);
  if p=0 then
    Result := s
  else
    Result := System.Copy(s, 1, p-1);
end;

function TWideStringCollection.BeforeRev(const cSet: array of WideChar; const s: WideString): WideString;
var
  i : integer;
begin
  for i := length(s) downto 1 do
  begin
    if WCharInArray(s[i], cSet) then
    begin
      Result := System.Copy(s, 1, i-1);
      exit;
    end;
  end;
  Result := s;
end;

function TWideStringCollection.At(const s: WideString; Index: integer): WideChar;
begin
  if (Index>0) and (Index <= Length(s))
  then Result := s[Index]
  else Result := WideNull;
end;

function TWideStringCollection.First(const s: WideString; count: integer): WideString;
begin
  Result := System.Copy(s, 1, count);
end;

function TWideStringCollection.Last(const s: WideString; count: integer): WideString;
begin
  Result := System.Copy(s, (Length(s)-count) + 1, Length(s));
end;

function TWideStringCollection.LastWChar(const s: WideString): WideChar;
begin
  Result := WideNull;
  if s <> '' then Result := s[Length(s)];
end;

{------------------------------------------------------------------------------}
function TWideStringCollection.FirstWChar(const s: WideString): WideChar;
begin
  Result := WideNull;
  if Length(s) > 0 then
    Result := s[1];
end;

{-------------------------------------------------------------------------------
*Parse - Extracts words,characters between delimiters.
 This function relies on After and Before; its Result is the string after
 SubStr, and before the next SubString. String S is thereafter
 reduced to : s -/- first substr -/- resulting string.
 Code by Reinder de Jager
 Example:
    s := '-a-b-c';
    while s<>'' do
    begin
      param := sc.parse('-',s);
      memo1.Lines.Add(param); //do what you want with param
    end;
    Memo Result: lines 'a','b','c'
See also the overloaded Set-version and After,Before
-------------------------------------------------------------------------------}
function TWideStringCollection.Parse(const SubStr: WideString; var s: WideString;
  Position: Cardinal): WideString;
var
  temp : WideString;
begin
  if IsSameFirst(SubStr, s) then
    temp:= After(SubStr, s, Position)
  else
    temp:= s;

  Result:= Before(SubStr, temp, Position);
  s := DelIfFirst(Result, temp);
end;

function TWideStringCollection.Parse(const cSet: array of WideChar; var s: WideString): WideString;
var
  temp : string;
begin
  if WCharInArray(FirstWChar(s), cSet) then
    temp := After(CSet, s)
  else
    temp:= s;
  Result := Before(cSet, temp);
  s := DelIfFirst(Result, temp);
end;

{-------------------------------------------------------------------------------
*Ins - function version of standard insert procedure.
 Example: Ins('a','1234',2) > '1a234'
 Example: Ins('a','1234',200) > '1234a'
-------------------------------------------------------------------------------}
function TWideStringCollection.Ins(const SubStr, s: WideString; Index: integer): WideString;
begin
  Result := s;
	System.Insert(SubStr, Result, Index);
end;

{-------------------------------------------------------------------------------
*Copy - Same as the standard Copy function.
 Example: Copy('ABCDEF', 2, 3) > 'BCD'
-------------------------------------------------------------------------------}
function TWideStringCollection.Copy(const s: WideString; Index, Count: integer): WideString;
begin
	Result := System.Copy(s, Index, Count);
end;

{-------------------------------------------------------------------------------
*SetAt - Just a safe way to set a char in a string.
 Instead of s[4] := 'a' use s := SetAt(s,'a',4)
-------------------------------------------------------------------------------}
function TWideStringCollection.SetAt(const s: WideString;
  const c: WideChar; Index: integer): WideString;
begin
  Result := s;
  if (Index = 0) or (Index > Length(s)) then exit;
  Result[Index] := c;
end;

{-------------------------------------------------------------------------------
*Center - Centers text in a string of length Len
 Example: Center('ok',6) > '  ok  '
-------------------------------------------------------------------------------}
function TWideStringCollection.Center(const s: WideString; Len: integer;
  PadChar: Widechar): WideString;
begin
  if Length(s) < Len then
  begin
    Result := RepeatChar(PadChar,(Len div 2) - (Length(s) div 2)) + s;
    Result := Result + RepeatChar(PadChar, Len - Length(Result));
  end
  else
    Result := s;
end;

{-------------------------------------------------------------------------------
*ReplaceChars
 Replaces all the occurences of OldChars with NewChar.
 Example:
  s := 'Replace e and a with *';
  ReplaceChars(s,['e','a'],'*') returns 'R*pl*c* * *nd * with *';
-------------------------------------------------------------------------------}
function TWideStringCollection.ReplaceChars(const s: WideString;
  OldChars: array of WideChar; NewChar: WideChar): WideString;
var
  i : integer;
begin
  Result := s;
  for i := 1 to Length(Result) do
  begin
    if WCharInArray(Result[i], OldChars) then
      Result[i] := newChar;
  end;
end;

function TWideStringCollection.Replace(FindStr, ReplaceWith, InStr: WideString;
  WholeWord, CaseSensitive: Boolean; Delims: array of WideChar): WideString;
var
  p : integer;
begin
  p := 1;
  Result := InStr;
  while p > 0 do
  begin
    Result := ReplaceFirst(FindStr, ReplaceWith, Result, WholeWord, CaseSensitive, Delims, p);
  end;
end;

function TWideStringCollection.Replace(FindStr, ReplaceWith, InStr: WideString): WideString;
begin
  Result := Replace(FindStr, ReplaceWith, InStr, false, true,[]);
end;



function TWideStringCollection.ReplaceFirst(FindStr, ReplaceAllStr, InStr: WideString;
  wholeword, CaseSensitive: Boolean; Delims: array of WideChar; var StartAt: integer): WideString;

   function Whole : boolean;
   var
    x : integer;
   begin
     Result := True;
     if wholeword = False then Exit;
     if StartAt > 1 then
     begin
       if not ((WCharInArray(instr[StartAt-1], Delims)) or (High(Delims) = 0)) then
       begin
         Whole := false;
         exit;
       end;
     end;
     x := StartAt + Length(FindStr);
     if x <= Length(instr) then
     begin
       if not ((WCharInArray(instr[x], Delims)) or (High(Delims) = 0)) then
       begin
         Whole := false;
         exit;
       end;
     end;
   end;

var
  doit : boolean;
begin
  if StartAt = 0 then
    StartAt := 1;
  Repeat
    doit := false;
    if CaseSensitive = false then
      StartAt := Pos(WideUpperCase(FindStr), WideUpperCase(instr), StartAt)
    else
      StartAt := Pos(FindStr, instr, StartAt);
    if StartAt > 0 then
    begin
      DoIt := Whole;
      if doit = false then
        inc(StartAt);
    end;
  Until (StartAt = 0) or (DoIt);
  if (DoIt) and (StartAt > 0) then
  begin
    Result := System.Copy(instr, 1, StartAt-1) + ReplaceAllStr +
      System.Copy(instr, StartAt + Length(FindStr), $FFF0);
    StartAt := StartAt + Length(ReplaceAllStr);
  end
  else begin
    Result := instr;
    StartAt := 0;
  end;
end;

{------------------------------------------------------------------------------}
function TWideStringCollection.RepeatChar(c: WideChar;  Count: integer): WideString;
var
  I: Integer;
begin
  SetLength(Result, Count);
  for I := 1 to Count do Result[I] := c;
end;

function TWideStringCollection.SlashAdd(const s: WideString): WideString;
begin
  if (Length(s) > 0) and (s[Length(s)] <> '\')
  then Result:= s + '\'
  else Result:= s;
end;

function TWideStringCollection.SlashDel(const s: WideString): WideString;
begin
  if (Length(s) > 0) and (S[Length(s)] = '\')
  then Result := System.Copy(s, 1, Pred(Length(s)))
  else Result := s;
end;



initialization
  scw := TWideStringCollection.Create;

end.
