unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    cbCheckSyntaxOnly: TCheckBox;
    edoutputsqlfile: TEdit;
    reOutputsqlstrings: TRichEdit;
    edinputsqlfile: TEdit;
    reInputsqlstrings: TRichEdit;
    GroupBox1: TGroupBox;
    rbReadfromfile: TRadioButton;
    rbreadfromstrings: TRadioButton;
    GroupBox2: TGroupBox;
    rbSavetostrings: TRadioButton;
    rbSavetofile: TRadioButton;
    btninputfile: TButton;
    OpenDialog1: TOpenDialog;
    Button2: TButton;
    procedure Button1Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure rbReadfromfileClick(Sender: TObject);
    procedure rbSavetofileClick(Sender: TObject);
    procedure rbSavetostringsClick(Sender: TObject);
    procedure rbreadfromstringsClick(Sender: TObject);
    procedure btninputfileClick(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

Uses GSqlParser;
{$R *.DFM}

procedure TForm1.Button1Click(Sender: TObject);
var
  agsqlparser : Tgsqlparser;
  i,ret:integer;
  s:String;
begin

try
  agsqlparser := Tgsqlparser.Create;

  reoutputsqlstrings.lines.clear;
  agsqlparser.CheckSyntaxOnly := cbCheckSyntaxOnly.checked;
  if rbreadfromfile.Checked then
    begin
      if length(edinputsqlfile.Text) = 0 then
        begin
          showmessage('Input file is not specified!');
          exit;
        end;
      agsqlparser.Sqlfilename := edinputsqlfile.Text;
    end
  else
    agsqlparser.SqlText := reinputsqlstrings.lines;

  if rbsavetofile.Checked then
    begin
      if length(edoutputsqlfile.Text) = 0 then
        begin
          showmessage('output file is not specified!');
          exit;
        end;
      agsqlparser.FormattedSqlfilename := edoutputsqlfile.Text;
    end;
  ret := agsqlparser.Parse;
  case ret of
    -1:
      reoutputsqlstrings.lines.add('Fatal error !');
    0:
      begin
        if not rbsavetofile.Checked  then
          reoutputsqlstrings.lines := agsqlparser.FormattedSqlText
        else
          if not agsqlparser.CheckSyntaxOnly then
            reoutputsqlstrings.lines.add('Formatted SQL were saved to '+edoutputsqlfile.Text)
          else
            reoutputsqlstrings.lines.add('Check syntax only,no formatted SQL were generated');
      end;
    else //>0
      begin
      for i:= 0 to agsqlparser.ErrorCount -1 do
      begin
        with agsqlparser do
          begin
            s := 'Error token:'+SyntaxErrors[i].Token;
            s:=s+'('+inttostr(SyntaxErrors[i].xposition);
            s:=s+','+inttostr(SyntaxErrors[i].yposition)+')';
            s:=s+' Expected token:'+SyntaxErrors[i].hint;
            reoutputsqlstrings.Lines.add(s);
          end;
      end;
      end;
  end;
  reoutputsqlstrings.enabled := true;
finally
  agsqlparser.free;
end;

end;

procedure TForm1.FormShow(Sender: TObject);
begin
//  edtestfile.Text := extractfilepath(application.exename)+'1.sql';
//  edoutputfile.Text:= extractfilepath(application.exename)+'1.txt';
   rbReadfromfileClick(nil);
   rbSavetoStringsClick(nil);
   opendialog1.InitialDir := extractfilepath(application.exename)+'test';
end;

procedure TForm1.rbReadfromfileClick(Sender: TObject);
begin
  edinputsqlfile.Enabled := rbReadfromfile.Checked;
  edinputsqlfile.Color := clwindow;
  edinputsqlfile.SetFocus;
  edinputsqlfile.SelectAll;
  btninputfile.Enabled := rbReadfromfile.Checked;
  reinputsqlstrings.Enabled := not rbReadfromfile.Checked;
end;

procedure TForm1.rbSavetofileClick(Sender: TObject);
begin
  edoutputsqlfile.Enabled := rbSavetofile.Checked;
  edoutputsqlfile.Color := clWindow;
  edoutputsqlfile.SetFocus;
  edoutputsqlfile.SelectAll;
  reoutputsqlstrings.Enabled := not rbSavetofile.Checked;
end;

procedure TForm1.rbSavetostringsClick(Sender: TObject);
begin
  edoutputsqlfile.Enabled := rbSavetofile.Checked;
  edoutputsqlfile.Color := clMenu;
  reoutputsqlstrings.Enabled := not rbSavetofile.Checked;
  reoutputsqlstrings.SetFocus;
end;

procedure TForm1.rbreadfromstringsClick(Sender: TObject);
begin
  edinputsqlfile.Enabled := rbReadfromfile.Checked;
  edinputsqlfile.Color := clMenu;
  btninputfile.Enabled := rbReadfromfile.Checked;
  reinputsqlstrings.Enabled := not rbReadfromfile.Checked;
  reinputsqlstrings.SetFocus;
end;

procedure TForm1.btninputfileClick(Sender: TObject);
begin
  if OpenDialog1.Execute then
    edinputsqlfile.Text := OpenDialog1.FileName;

  edoutputsqlfile.Text := edinputsqlfile.Text+'.fmt';
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  close;
end;

end.
