-- simple expression
--select /*+ hint */ 9  from  dual;
select 'this is a text string' from dual;

select N'this is an NCHAR string' from dual;
select null from dual;
select sequence_name.currval from dual;
select sequence_name.nextval from dual;
select empno from emp;
select emp.empno from emp;
select scott.emp.empno from emp;


--compound expression
select -2 from dual;
select +3 from dual;
select PRIOR 2 from dual;
select (-2) from dual;
select 1+2 from dual;
select 1-2 from dual;
select 1*2 from dual;
select 1/2 from dual;
select ('clark'||'smmith') from dual;
select length('moose')*57 from dual;
select my_fun(to_char(sysdate,'dd-mm-yy')) from dual;


--case expression
select cust_last_name,
case credit_limit when 100 then 'Low'
when 500 then 'High'
else 'Medium' end
from customers;


select avg(case  when e.salary > 2000 then e.salary else 2000 end) 
"average salary" from employee e;

--decode function
select last_name,
decode(job_id,'It_prog',1.10*salary,'st_clerk',1.15*salary,'sa_rep',1.20*salary,
salary)
revised_salary
from employees;

select last_name,salary,
decode(trunc(salary/2000,0),
0,0.00,
1,0.09,
2,0.20,
3,0.30,
0.55) tax_rate
from employees
where department_id = 80;

--cursor expression
select department_name,cursor(select salary,commission_pct 
from employees e 
where e.department_id=d.department_id)
from departments d;

--datetime expression
--select start_time + interval '1-2' year to month from schedule;

--interval expression
--select (systimestamp - order_date) day to second from orders;

--scalar subquery expression
--no test case yet

--type constructor expression
--no test case yet

--variable expression
--no test case yet

--expression list
select sysdate from dual
where 1 in (10,20,30);