--Using column aliases 

select last_name as name ,commission_pct comm,
salary*12 "Annual Salary"
from employees;

select last_name || ' is a '||job_id
As "Employee Details"
from employees;


--Eliminating duplicate rows
select distinct department_id
from employees;

select unique department_id
from employees;


--for update clause
select all department_id
from employees
for update;

select all department_id
from employees
for update of scott.emp.ename;

select all department_id
from employees
for update nowait;

select all department_id
from employees
for update wait 15;


--Where clause
select employee_id,last_name
from employees
where department_id = 90;

select employee_id,last_name
from employees
where manager_id in (1,2,3);
 
select employee_id,last_name
from employees
where last_name like '_o%';

select employee_id,last_name
from employees
where manager_id is null;


--Order by clause
select last_name,job_id
from employee
order by hire_date;

select last_name,job_id
from employee
order by hire_date asc;

select last_name,job_id
from employee
order by hire_date desc;

select last_name,job_id
from employee
where manager_id is null
order by department_id,salary desc;

--Group by clause
select avg(salary),max(salary),
min(salary),sum(salary)
from employees
where job_id like '%rep%';

select count(*) 
from employees
where department_id = 90;

select count(department_id) 
from employees
where department_id = 90;

select count(distinct department_id) 
from employees
where department_id = 90;


select department_id,avg(salary)
from employees
group by department_id;

select department_id,avg(salary)
from employees
group by department_id
order by avg(salary);

select department_id dept_id,job_id, sum(salary)
from employees
group by department_id,job_id;


select department_id,avg(salary)
from employees
group by department_id
having avg(salary) > 8000;

select department_id,avg(salary)
from employees
group by department_id
having avg(salary) > 8000
order by sum(salary);

--SQL functions
select 'The job id for '||upper(last_name)|| ' is '
||lower(job_id) as "employee details"
from employees;

select concat('Hello','World'),
substr('Helloworld',1,5),
length('Helloworld'),
instr('HelloWorld','w'),
Lpad(salary,10,'*'),
rpad(salary,10,'*'),
trim('h' From 'HelloWorld')
from dual;


select round(45.993,2),
trunc(45.9235,2),
mod(1600,234)
from dual;

select last_name, (sysdate-hire_date)/7 as weeks
from employee
where department_id = 90;

select months_between('01-sep-95','12-Jan-89'),
add_months('11-jan-94',6),
next_day('01-sep-98','friday'),
last_day('01-feb-95'),
round(sysdate,'month'),
round(sysdate,'year'),
trunc(sysdate,'month')
from dual;

select employee_id,to_char(hire_date,'mm/yy') Month_hired
from employees
where hire_date = to_date('May 23,1999','fxMonth DD,YYYY')
or to_date(hire_date,'DD-Mon-yy')<'01-jan-2000';


select last_name,
Nvl(to_char(manager_id),'No Manager')
from employees
where manager_id is null
order by hire_date;

